/*
 *  fntlda.c - 樮 ணࠬ  ணࠬ஢
 *             ନ -280 v.1.65
 *
 */

#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#ifndef DOS
#include <unistd.h>
#include <termio.h>
#else
#include <bios.h>
#define _COM_CHR8 3
#define _COM_STOP1 0
#define _COM_NOPARITY 0
#define _COM_9600 0xE0
int port = 0;         /* COM-port, COM1 by default    */
#endif

#define FALSE 0
#define TRUE 1

#define MAX_NAME 80
#define FNT_LEN 4096

extern int optind, opterr, optopt;
extern char *optarg;

#ifdef DOS
char usage[] = {
"\nUsage :\n\n fntlda [/q] [/r] [/p com-port] [/f font_file] [/1 kbd_file] [/2 kbd_file]\n\
\t[/F fkb_file] [/m map_file] [/M print_map_file] [/d cod]\n\
\nwhere:\n\
\tq - Quiet mode (don't show character table at the end)\n\
\tp - COM-port number. Parameter com-port may be 1 (default) or 2\n\
\tr - Restore defaults\n\
\tf - Load 8x16 VGA font from font_file\n\
\t1 - Load keyboard definition for 1st alternative set (RUS)\n\
\t    from kbddef_file\n\
\t2 - Load keyboard definition for 2nd alternative set (UKR)\n\
\t    from kbddef_file\n\
\tF - Load functional keyboard definition\n\
\tm - Load screen mapping from map_file\n\
\tM - Load local printer mapping from print_map_file\n\
\td - Set status line delimiter as character with hex code `cod`\n\
"};
#else
char usage[] = {
"\nUsage :\n\n fntlda [-qr] [-f font_file] [-1 kbd_file] \
[-2 kbd_file] [-F fkb_file]\n\t[-m map_file] [/M print_map_file] \
[-d cod]\n\
\nwhere:\n\
\tq - Quiet mode (don't show character table at the end)\n\
\tr - Restore defaults\n\
\tf - Load 8x16 VGA font from font_file\n\
\t1 - Load keyboard definition for 1st alternative set (RUS)\n\
\t    from kbddef_file\n\
\t2 - Load keyboard definition for 2nd alternative set (UKR)\n\
\t    from kbddef_file\n\
\tF - Load functional keyboard definition\n\
\tm - Load screen mapping from map_file\n\n\
\tM - Load local printer mapping from print_map_file\n\
\td - Set status line delimiter as character with hex code `cod`\n\
"};
#endif

#define RUS 1
#define UKR 2

/*****************************************************************
 **                                                             **
 **                     Main Procedure                          **
 **                                                             **
 *****************************************************************/

main(int argc, char **argv) {

  char buf[MAX_NAME];

  int c;
  int quiet = FALSE;
  int errflg = 0;
  int kbdtype = 0;

  errflg = init_screen(TRUE);   /* 樠 ࠭ */
  /*
   *    ப  믮
   */
  if (argc < 2) errflg++;       /*  ࠬ஢ - ᪠   */

  /* ᬮ 祩    */
#ifdef DOS
  while ((c = getopt(argc, argv, "qrf:1:2:F:m:M:d:p:")) != EOF) {
#else
  while ((c = getopt(argc, argv, "qrf:1:2:F:m:M:d:")) != EOF) {
#endif
    switch (c) {

    case 'f': /* 㧨 䮭 */
              errflg += load_font(optarg);
              break;

    case '1': /* 㧨 䠢⭮-஢   RUS  */
              errflg += load_key(optarg, 0);
              kbdtype |= RUS;
              break;

    case '2': /* 㧨 䠢⭮-஢   UKR  */
              errflg += load_key(optarg, 1);
              kbdtype |= UKR;
              break;

    case 'F': /* 㧨 㭪樮   UKR      */
              errflg += load_fkb(optarg);
              break;

    case 'm': /* 㧨 ४஢ ࠭ */
              errflg += load_map(optarg);
              break;

    case 'M': /* 㧨 ४஢ ਭ */
              errflg += load_printmap(optarg);
              break;

    case 'q': /*  뢮  ⠡  襭      */
              quiet = TRUE;
              break;

    case 'r': /* ⠭ 祭  㬮砭              */
              errflg += restore_defaults();
              break;

    case 'd': /* । ࠧ⥫ ᭮ ப         */
              errflg += define_delim(optarg);
              break;

#ifdef DOS
    case 'p': /*  COM- (1  2)      */
              port = atoi(optarg) - 1;
              if ((port != 0) && (port != 1)) {
                 fprintf(stderr, "ERROR: Port number may be only 1 or 2");
                 exit(1);
              }
              errflg += init_screen(TRUE);   /* 樠 ࠭ */
              break;
#endif
    default:  /*  ।  - 訡                   */
              errflg++;
              break;
    }
  }
  if (errflg) {                 /* ᫨ 뫠    訡 */
     init_screen(FALSE);        /* 樠㥬 ࠭        */
     fprintf(stderr, usage);    /* 뢥 ᪠             */
     exit(1);                   /*  멤  訡            */
  }

  if (kbdtype) {                /* 뫠  ८। . .*/
    switch (kbdtype) {
    case RUS: c = 6;            /*  - ᪠                  */
              break;
    case UKR: c = 5;            /*  - ࠨ᪠               */
              break;

    case UKR|RUS: c = 7;        /*  -                       */
                  break;
    }
    printf("\033l%d", c);       /* ⠭ NRAM  ८। */
  }
#ifndef DOS
  init_screen(FALSE);           /* 樠஢ ନ   */
#endif

  if (!quiet) {
#ifdef DOS
    init_screen(2);
#endif
    show_table();     /* ᫨  饭 - 뢮  ⠡ */
  }
}

/*****************************************************************
 **                                                             **
 **             ᭮ ணࠬ                           **
 **                                                             **
 *****************************************************************/
/*
 * 樠 / 樠 ନ
 */

init_screen(int ini) {
#ifndef DOS
  static struct termio old_tio;  /*  砫 ࠬ஢  */
  static struct termio tio;
  static int sd;

  if (ini) {
     /* 樠   */
     sd = fileno(stdout);
     ioctl(sd, TCGETA, &old_tio); /* ⠥ 砫 ࠬ   */
     /*  ࠬ   ८ࠧ 뢮        */
     memcpy(&tio, &old_tio, sizeof(struct termio));
     tio.c_iflag &= 0;
     tio.c_oflag=0;
     tio.c_lflag=0;
  }
  else /* 樠 */
    memcpy(&tio, &old_tio, sizeof(struct termio));

  if (ioctl(sd, TCSETA, &tio)) {  /*  ࠬ   */
     perror("Can't init tty");
     return(1);
  }

#else
  char buf[80];

  if (ini) {
    sprintf(buf, "COM%d", port+1);
    if (ini == 1) {
     bioscom(0, _COM_CHR8 | _COM_STOP1 | _COM_NOPARITY | _COM_9600, port);

     freopen(buf, "wb", stdout);
     close(fileno(stdout));     /* ⮢ Borland -   ⠪ ... */
     open(buf, O_WRONLY | O_BINARY);

    }
    else
      if (freopen(buf, "w", stdout)  == NULL) {
        perror(buf);
        exit(1);
      }
  }
  else
     freopen("CON", "w", stdout);
#endif

  return(0);
}

/*
 * ⠭ 祭  㬮砭
 */
int restore_defaults() {
 char buf[300];
 register int i, j;

 define_delim("b3");    /* ⠭ ࠧ⥫ ᭮ ப */
 printf("\033[:#F");    /* ⠭ 䮭    */
 printf("\033l4");      /* ⠭                 */
 printf("\033l2");      /* ⠭ 㭪樮     */

 strcpy(buf, "\033l8"); /* ⠭ ⠡ ४஢ ࠭     */
 j = strlen(buf);
 for (i=0; i<256; i++) buf[j+i] = (char) i & 0xff;
 i += j;
#ifdef DOS
 return(fwrite(buf, i, 1, stdout) != 1);
#else
 return(write(fileno(stdout), buf, i) != i);
#endif
}

/*
 * 㧪 䮭  䠩
 *
 */
int load_font
(char *fn)      /*  䠩 䮭 VGA 8x16     */
{
  char fnt[FNT_LEN];

#ifdef DOS
  if (freopen(fn, "rb", stdin) == NULL) {       /*  . 䠩     */
#else
  if (freopen(fn, "r", stdin) == NULL) {       /*  . 䠩     */
#endif
     perror(fn);
     return(1);
  }

  read(fileno(stdin), fnt, FNT_LEN);       /*   䮭         */
  fread(fnt, FNT_LEN, 1, stdin);
  printf("\033P");              /*  ନ: ਭ 䮭 */
  fflush(stdout);

  /* 뢥 䮭; 訡 ᫨ -  ⠪  뢮          */
#ifdef DOS
  return(fwrite(fnt, FNT_LEN, 1, stdout) != 1);
#else
  return(write(fileno(stdout), fnt, FNT_LEN) != FNT_LEN);
#endif
}

/*
 * 㧪 䠢⭮-஢ ᪫ 
 *
 */
int load_key
(char *fn,      /*  室 䠩 ᠭ  */
 int half)      /*     : 0 - RUS; 1 - UKR */
{
  register int i, j;
  char bufout[100], bufin[100];

  if (freopen(fn, "r", stdin) == NULL) {       /*  . 䠩     */
     perror(fn);
     return(1);
  }
  sprintf(bufout, "\033l%d", half);     /* ਭ ⠡. ८। */

  /* 襬    뢮 ⠡ ८।      */
  j = strlen(bufout);
  for (i=0; i<94; i++) {        /*    祬 94    */
                                /* ⠥ ப . 䠩 ᠭ  */
     if (fgets(bufin, 100, stdin) == NULL) break; /* EOF - 稫 */
     if (!strlen(bufin)) continue; /*  ப - ய᪠     */
     if (isspace(bufin[0])) continue; /* 稭 ஡ - ய᪠ */
     parse_ks(bufin, &bufout[j+i], 1);/* ॢ ᠭ     */
  }
  for (;i<94;i++) bufout[j+i] = '\0'; /* 㫨 ⮪       */
  j += i;

  /* 뢥  ; 訡 ᫨ -  ⠪  뢮           */
#ifdef DOS
  return(fwrite(bufout, j, 1, stdout) != 1);
#else
  return(write(fileno(stdout), bufout, j) != j);
#endif
}

/*
 * 㧪 ⠡ ४஢ 뢮  ࠭
 *
 */
int load_map
(char *fn)      /*  室 䠩 ᠭ  */
{
  register int i, j;
  char bufout[300], bufin[100];
  int k;

  if (freopen(fn, "r", stdin) == NULL) {       /*  室 䠩 */
     perror(fn);
     return(1);
  }
  sprintf(bufout, "\033l8");    /* ਭ ⠡ ४஢ */
  j = strlen(bufout);
  for (i=0; i<256; i++) {/*  256 ᨬ             */
                         /* ⠥ ப . 䠩 ᠭ     */
     if (fgets(bufin, 100, stdin) == NULL) break; /* EOF - 稫 */
     if (!strlen(bufin)) continue;   /*  ப - ய᪠  */
     if (isspace(bufin[0])) continue;/* 稭 ஡ - ய᪠ */
     parse_ks(bufin, &bufout[j+i], 1);/* ॢ ᠭ    */
  }
  /* ⮪  - ४஢          */
  for (;i<256;i++) bufout[j+i] = (char) i & 0xff;
  j += i;
#ifdef DOS
  if (fwrite(bufout, j, 1, stdout) == 1) i = j;
  else i = 0;
#else
  i = write(fileno(stdout), bufout, j); /* 뢥    */
#endif

  printf("\033!g7");    /* Character Set = NRAM                 */
  return(i != j);       /* 訡 ᫨ -  ⠪  뢮  */
}

/*
 * 㧪 ⠡ ४஢ 뢮   ਭ
 *
 */
int load_printmap
(char *fn)      /*  室 䠩 ᠭ  */
{
  register int i, j;
  char bufout[200], bufin[100];
  int k;

  if (freopen(fn, "r", stdin) == NULL) {       /*  室 䠩 */
     perror(fn);
     return(1);
  }
  sprintf(bufout, "\033lp");    /* ਭ ⠡ ४஢ */
  j = strlen(bufout);
  for (i=0; i<128; i++) {/*  128 ᨬ             */
                         /* ⠥ ப . 䠩 ᠭ     */
     if (fgets(bufin, 100, stdin) == NULL) break; /* EOF - 稫 */
     if (!strlen(bufin)) continue;   /*  ப - ய᪠  */
     if (isspace(bufin[0])) continue;/* 稭 ஡ - ய᪠ */
     parse_ks(bufin, &bufout[j+i], 1);/* ॢ ᠭ    */
  }
  /* ⮪  - ४஢          */
  for (;i<128;i++) bufout[j+i] = (char) i & 0xff;
  j += i;
#ifdef DOS
  if (fwrite(bufout, j, 1, stdout) == 1) i = j;
  else i = 0;
#else
  i = write(fileno(stdout), bufout, j); /* 뢥    */
#endif

  printf("\033lP1");    /* Mapping = Host                       */
  return(i != j);       /* 訡 ᫨ -  ⠪  뢮  */
}

/*
 * 㧪 㭪樮쭮 
 *
 */
int load_fkb
(char *fn)      /*  室 䠩 ᠭ  */
{
  register int i, j;
  int k, l;
  int nk;
  char id;
  unsigned char buf[1024];
  unsigned char kbuf[6], sbuf[80];

  if (freopen(fn, "r", stdin) == NULL) {       /*  . 䠩 */
     perror(fn);
     return(1);
  }
  sprintf(buf, "\033\060 ");    /* ਭ ८। . .  */
  j = strlen(buf);
  nk = 0;                       /* ⢮ ८।塞  */
  id = '\037';                  /* 䨪               */
  for (i=0; i<90; i++) {        /*  90 㭪樮         */
     id++;                      /* ६஢ 䨪     */
     /* ⠥ ப . 䠩 ᠭ                              */
     if (fgets(sbuf, 80, stdin) == NULL) break; /* EOF - 稫    */
     if (!strlen(sbuf)) continue;   /*  ப - ய᪠     */
     if (isspace(sbuf[0])) continue;/* 稭 ஡ - ய᪠*/
     nk++;                      /* ६஢ ⢮  */
     buf[j++] = id;             /* . 䨪 ->  뢮 */
     l = parse_ks(sbuf, kbuf, 5);/* ॢ ᠭ           */
     buf[j++] = (char) ('0' + l);/*  ᫥⥫쭮 ->  */
     for (k=0; k<l; k++) {      /*  -  16-筮 ।⠢   */
        sprintf(&buf[j],"%02X", kbuf[k]);
        j += 2;
     }
  }
  if (nk) {                     /* ᫨    ८। */
     buf[2] = (char) (nk + 040);/* - ८.  -> . 뢮 */

#ifdef DOS
  if (fwrite(buf, j, 1, stdout) == 1) i = j;
  else i = 0;
#else
  i = write(fileno(stdout), buf, j); /* 뢥    */
#endif

     printf("\033l97");         /* Keyboard Emulation = NRAM    */
  }
  else i = j;  /*     ८। - ਪ  OK */
  return(i != j);       /* 訡  -  ⠪  뢮  */
}


/*
 * । ࠧ⥫ ᭮ ப
 *
 */
int define_delim
(char *hc)      /*  ࠧ⥫ - ப 16-       */
{
 int i;
 sscanf(hc, "%x", &i);
 printf("\033l!%c", i);
 return(0);
}

/*
 * 뢮  ⠡
 *
 */
show_table() {
#define cmin 0x20
#define cmax 0xff

  int i, j, c;

  printf("\n\n    ");
  for (i=cmin; i <= cmax ; i += 0x10) printf("  %2X", i);
  putchar('\n');
  printf("----");
  for (i=cmin; i<=cmax; i+= 0x10) printf("----");
  putchar('\n');
  for (i=0; i <= 0x0f; i++) {
    printf("%x  |", i);
    for (j=cmin; j<= cmax; j+=0x10) {
      if ((c=j+i) < 0x20) printf("  \033[=%dg ", c);
      else printf("  %2c", c);
    }
  printf("|  %x\n", i);
  }
  printf("\n\nDon't forget to save SetUp !\n");
}

/*****************************************************************
 **                                                             **
 **             ᯮ⥫ ணࠬ                    **
 **                                                             **
 *****************************************************************/
/*
 * ࠭ ᨬ쭮 ப  몥 ᠭ Esc-᫥⥫쭮⥩
 *  ᮡ⢥ ᫥⥫쭮 

    몠 ᠭ :
   \777 - 쬥 
   \xAA - ⭠ 
   \d99 -  
   \n   - ^J
   \r   - ^M
   \E, \e - Esc
   ^A   - ^A
    䠢⭮-஢ ᨬ =  
    ᠭ - ஡  ⨦ ⨬ ᨬ㬠

 */

int parse_ks    /* 頥  ᫥⥫쭮   */
(char *ks,      /* 室 ப ᠭ                      */
 char *buf,     /* 室                           */
 int  max)      /* ᨬ쭮 ⨬  ᫥⥫쭮 */
{
#define COD  1
#define CTRL 2
#define HEXCOD 4
#define DECCOD 8
#define isodigit(dc) ((dc >= '0') && (dc <= '7'))

   register int i, j;
   int c;
   int flag;

   i = j = flag = 0;
   while (!isspace(c = ks[i] & 0xFF)) {
      if (j >= max) break;
      switch (c) {
      case '\\':
                 if (flag & COD) goto was_backslash;
                 flag |= COD;
                 i++;
                 break;
      case '^':
                 if (flag & COD) goto was_backslash;
                 flag |= CTRL;
                 i++;
                 break;
      default:
                 if (flag) {
was_backslash:
                    if (flag & COD) {
                        if (isodigit(c)) {
                           sscanf(&ks[i], "%o", &c);
                           buf[j++] = (char) c;
                           while (c = ks[i] & 0xFF)
                              if (!isodigit(c)) break;
                              else i++;
                        }
                        else {
                           switch (c) {
                             case '\\' : buf[j++] = '\\';
                                         break;
                             case 'x'  :
                                         flag |= HEXCOD;
                                         break;
                             case 'd'  :
                                         flag |= DECCOD;
                                         break;
                             case 'n'  :
                                         buf[j++] = '\n';
                                         break;
                             case 'r'  :
                                         buf[j++] = '\r';
                                         break;
                             case 'e'   :
                             case 'E'   :
                                         buf[j++] = '\033';
                                         break;
                             default    :
                                         buf[j++] = (char) c;
                                         break;
                           }
                           i++;
                        }
                    flag &= ~(COD | CTRL);
                    }
                    else if (flag & HEXCOD) {
                       sscanf(&ks[i], "%x", &c);
                       buf[j++] = (char) c;
                       while (c = (int) ks[i] & 0xFF)
                         if (!isxdigit(c)) break;
                         else i++;
                       flag &= ~HEXCOD;
                    }
                    else if (flag & DECCOD) {
                       sscanf(&ks[i], "%d", &c);
                       buf[j++] = (char) c;
                       while (c = (int) ks[i] & 0xFF)
                         if (!isdigit(c)) break;
                         else i++;
                       flag &= ~DECCOD;
                    }
                    else if (flag & CTRL) {
                       if (c >= 0100) c &= ~(0140);
                       buf[j++] = (char) c;
                       flag &= ~CTRL;
                       i++;
                    }
                 }
                 else {
                    buf[j++] = (char) c;
                    i++;
                 }
      }
   }
   return(j);
}

